-- O
local setting
local outputDir, imageDir, isTrim, compressLevel, outputMode
for line in io.lines("arguments.txt") do
    -- ݒ̓ǂݍ
    if setting == nil then
        setting = {}
        for key, value in string.gmatch(line, "([^\x09=]+)=([^\x09]*)") do
            setting[key] = value
        end
        -- ݒ̎擾
        outputDir = setting["outputDir"]
        imageDir = setting["imageDir"]
        isTrim = setting["isTrim"]
        compressLevel = setting["compressLevel"]
        outputMode = setting["outputMode"]
    end
end
-- ݒt@C폜
local success, args = pcall(os.remove("arguments.txt"))

-- 
local list = getFileList(imageDir, "*", 3) -- 3: 12̘_a
local len = string.len(imageDir) + 1
local faceFile = {}
local imageFileNum, imageFileList = 1, {}

-- CxgG
if outputMode == "event" then
    local step
    -- loop "file path"
    for i, path in ipairs(list) do
        -- Ώۂ*.bmp*.pnĝ
        if getExtensionName(path) == ".bmp" or getExtensionName(path) == ".png" then
            -- qtH_ޔp̕ϐ擾
            local subDir = getParentFolderName(string.sub(path, len))
            subDir = (subDir == "") and "\\" or subDir
            local headName = getBaseName(path)
            local fileType, partType =
                string.match(headName, "^(CG_[A-Z][A-Z][0-9][0-9])_([BF0-9])")
            if not fileType then
                fileType, partType =
                    string.match(getParentFolderName(path),
                                 "[/\\](CG_[A-Z][A-Z][0-9][0-9])_([BF])A[CS]E[/\\]$")
            end

            -- 摜ނ̐؂ւɂ鏉
            if step ~= fileType then
                step = fileType
                for num = 0, imageFileNum do
                    freeImage(num)
                end
                faceFile = {}
                imageFileNum, imageFileList = 1, {}
            end

            -- BASE
            if partType == "B" then
                -- gݍ킹Xg
                local pairList = {
                                     CG_CB01 = {
                                                   {"[01]$", "[^89]$"},
                                                   {"2$", "9$"},
                                                   {"[3-6]$", "[^9]$"}
                                               },
                                     CG_CB03 = {
                                                   {"[02356]$", "[02][0-4]$"},
                                                   {"[14]$", "1[5-9]$"}
                                               },
                                     CG_CE02 = {
                                                   {"0$", {"0[0-6]$", "1[5-9]$", "2[01]$"}},
                                                   {"1$", {"0[7-9]$", "1[0-4]$"}}
                                               },
                                     CG_CR03 = {
                                                   {"[0246]$", "[0-2][0-4]$"},
                                                   {"[1357]$", {"[0-2][5-9]$", "30$"}}
                                               },
                                     CG_CR08 = {
                                                   {"0$", "0[0-5]$"},
                                                   {"[1-3]$", {"0[6-9]$", "1[01]$"}}
                                               },
                                     CG_IB01 = {
                                                   {"00$", "0[0-8]$"},
                                                   {"01$", {"0[9]$", "1[0-2]$"}},
                                                   {"0[23]$", "1[3-5]$"},
                                                   {"0[48]$", {"29$", "3[0-2]$"}},
                                                   {"[01][59]$", "2[0-8]$"},
                                                   {"0[67]$", "1[3-5]$"},
                                                   {"10$", {"29$", "3[0-2]$"}},
                                                   {"1[1237]$", "1[3-5]$"},
                                                   {"14$", {"29$", "3[0-4]$"}},
                                                   {"16$", {"29$", "3[0-2]$", "3[56]$"}},
                                               },
                                     CG_IE05 = {
                                                   {"0$", "[0-367]$"},
                                                   {"1$", "[45]$"}
                                               },
                                     CG_IO02 = {
                                                   {"[0-4]$", "[0-4]$"},
                                                   {"6$", "[0-4]$"},
                                                   {"[57]$", "[5-8]$"}
                                               },
                                     CG_IO05 = {
                                                   {"0[0-3]$", "0[0-8]$"},
                                                   {"0[7-9]$", "0[0-8]$"},
                                                   {"0[4-6]$", {"09$", "1[0-7]$"}},
                                                   {"1[01]$", "0[0-8]$"},
                                                   {"1[2-4]$", {"09$", "1[0-7]$"}}
                                               },
                                     CG_IO09 = {
                                                   {"0[01289]$", "0[0-8]$"},
                                                   {"0[3-7]$", "1[0-8]$"},
                                                   {"10$", "0[0-8]$"},
                                                   {"1[1-3]$", "1[0-8]$"}
                                               },
                                     CG_LE06 = {
                                                   {"0$", {"0[0-9]$", "1[0-5]$"}},
                                                   {"1$", "1[67]$"}
                                               },
                                     CG_LS01 = {
                                                   {"[0-3]$", "[0145]$"},
                                                   {"[56]$", "[0145]$"},
                                                   {"4$", "[23]$"}
                                               },
                                     CG_LS02 = {
                                                   {"[026]$", "0[0-3]$"},
                                                   {"[137]$", "[5-9]$"},
                                                   {"4$", {"4$", "12$"}},
                                                   {"5$", "1[01]$"}
                                               },
                                     CG_LS07 = {
                                                   {"00$", {"2[5-9]$", "30$"}},
                                                   {"01$", {"0[0-7]$", "2[5-9]$", "30$"}},
                                                   {"0[2349]$", {"0[0-7]$", "1[4-9]$", "2[5-9]$", "30$"}},
                                                   {"[5-8]$", {"0[8-9]$", "1[0-3]$", "2[0-4]$"}},
                                                   {"1[01]$", {"0[0-7]$", "1[4-9]$", "2[5-9]$", "30$"}},
                                                   {"12$", {"0[8-9]$", "1[0-3]$", "2[0-4]$"}}
                                               },
                                     CG_LS11 = {
                                                   {"0[02]$", "0[0-6]$"},
                                                   {"1$", "25$"},
                                                   {"[3478]$", {"0[7-9]$", "1[0-4]$"}},
                                                   {"[59]$", "1[5-6]]$"},
                                                   {"6$", {"1[7-9]]$", "2[0-4]$"}},
                                                   {"10$", {"1[7-9]]$", "2[0-4]$"}}
                                               },
                                     CG_MY01 = {
                                                   {"0$", {"[01]$", "[67]$"}},
                                                   {"1$", {"[2-5]$", "[89]$"}}
                                               },
                                     CG_MY03 = {
                                                   {"0$", {"[0-9]$", "1[0-4]$"}},
                                                   {"[12]$", "1[56]$"}
                                               },
                                     CG_OP03 = {
                                                   {"0$", "[0-4]$"},
                                                   {"[1-4]$", "[5-9]$"}
                                               },
                                     CG_OP04 = {
                                                   {"[01]$", "[0-2]$"},
                                                   {"[23]$", "[3-5]$"}
                                               },
                                 }

                -- BASE摜FACE摜
                local targetFaceFile = faceFile[fileType] -- BASE摜ƑΉFACE摜̃pX
                if targetFaceFile ~= nil then
                    loadImage(imageFileNum, path)
                    local posX, posY = 0, 0
                    -- ΉFACE摜̏
                    for j, facePath in pairs(targetFaceFile) do
                        local faceNum = string.match(getBaseName(facePath), "[0-9][0-9][0-9][0-9]$") or
                                        getBaseName(facePath)
                        -- gݍ킹XgɊY邩ǂ(XgɂȂ摜͍Ώ)
                        local isBaseFile = true
                        local isFaceFile = true
                        if pairList[fileType] ~= nil then
                            -- BASE摜̔
                            local isBaseFile
                            local pairNum
                            for k, reNum in pairs(pairList[fileType]) do
                                isBaseFile = string.match(headName, reNum[1])
                                if isBaseFile ~= nil then
                                    pairNum = k
                                    break
                                end
                            end
                            -- FACE摜̔
                            if isBaseFile ~= nil then
                                local pairFace = pairList[fileType][pairNum][2]
                                if type(pairFace) == "table" then
                                    for k, reNum in pairs(pairFace) do
                                        isFaceFile = string.match(faceNum, reNum)
                                        if isFaceFile ~= nil then
                                            break
                                        end
                                    end
                                else
                                    isFaceFile = string.match(faceNum, pairFace)
                                end
                            end
                        end
                        -- 摜̍
                        if isBaseFile ~= nil and isFaceFile ~= nil then
                            copyImage(0, imageFileNum)
                            local blendImageNum = imageFileList[facePath]
                            blendImage(0, blendImageNum, 1, posX, posY)
                            if isTrim == "1" then
                                trimmingImage(0, "UDLR")
                            end
                            local fileNum = string.match(headName, "[0-9][0-9][0-9][0-9]$") or "0000"
                            local outputFileName = outputDir .. subDir .. fileType .. "_" ..
                                                   fileNum .. "_" .. faceNum .. ".png"
                            saveImage(0, outputFileName, 1, 0, tonumber(compressLevel), 0)
                            print("output: " .. outputFileName .. "\n")
                        end
                    end
                end
            -- FACE
            elseif partType == "F" then
                -- Ȃ\
                local nilFile = {CG_CB03 = "1[0-4]$",
                                 CG_CR03 = "[01][89]$",
                                 CG_IB01 = "1[6-9]$",
                                 CG_IO09 = "9$"}
                local nilFileFlg
                if nilFile[fileType] ~= nil then
                    nilFileFlg = string.match(getBaseName(path), nilFile[fileType])
                end

                -- \̓ǂݍ
                if not nilFileFlg then
                    loadImage(imageFileNum, path)
                    imageFileList[path] = imageFileNum
                    imageFileNum = imageFileNum + 1
                    -- \̎ޕ
                    if not faceFile[fileType] then
                        faceFile[fileType] = {}
                    end
                    table.insert(faceFile[fileType], path)
                end
            -- sv̉摜
            elseif partType ~= nil then
                local isNum = string.match(partType, "^[0-9]$")
                if isNum ~= nil then
                    local notTarget = string.match(getBaseName(path), "00$")
                    if not notTarget then
                        loadImage(0, path)
                        if isTrim == "1" then
                            trimmingImage(0, "UDLR")
                        end
                        local outputFileName = outputDir .. subDir .. getBaseName(path) .. ".png"
                        saveImage(0, outputFileName, 1, 0, tonumber(compressLevel), 0)
                        print("output: " .. outputFileName .. "\n")
                    end
                end
            end

        end
        -- if "*.bmp or *.png" end
    end
    -- loop "file path" end

-- G
else
    local person
    -- loop "file path"
    for i, path in ipairs(list) do
        -- Ώۂ*.bmp*.pnĝ
        if getExtensionName(path) == ".bmp" or getExtensionName(path) == ".png" then
            -- qtH_ޔp̕ϐ擾
            local subDir = getParentFolderName(string.sub(path, len))
            subDir = (subDir == "") and "\\" or subDir
            local headName = getBaseName(path)
            local fileType, nowPerson, standType, partType =
                string.match(headName, "^((B[A-Z]_[A-Z][A-Z])_[_0-9]_([0-9]))([_0])")
            if not fileType then
                fileType, nowPerson, standType, partType =
                    string.match(getParentFolderName(path),
                                 "[/\\]((B[A-Z]_[A-Z][A-Z])_[_0-9]_([0-9]))(_)Face[/\\]$")
            end
            if not fileType then
                fileType, nowPerson, standType, partType =
                    string.match(headName, "^(([BF][A-Z]_[A-Z][A-Z])_([0-9]))(0)")
            end

            -- 摜ނ̐؂ւɂ鏉
            if person ~= nowPerson then
                person = nowPerson
                for num = 0, imageFileNum do
                    freeImage(num)
                end
                faceFile = {}
                imageFileNum, imageFileList = 1, {}
            end

            -- body
            if partType == "0" then
                -- GɑΉ\擾
                local targetFaceFile
                if not faceFile[fileType] then
                    targetFaceFile = faceFile[person .. "___" .. standType]
                else
                    targetFaceFile = faceFile[fileType]
                end
                local notTarget = string.match(getBaseName(path), "_0[0-9]$")
                -- "BS_LS_6_105""BS_LS_6_106"͍sv(摜)
                local nilFile = {}
                nilFile["BS_LS_6_105"] = true
                nilFile["BS_LS_6_106"] = true

                -- 摜̍
                if targetFaceFile ~= nil and not notTarget and not nilFile[headName] then
                    loadImage(imageFileNum, path)
                    local posX, posY = 0, 0
                    -- "BS_RY___1"̈ʒu␳
                    if person .. "___" .. standType == "BS_RY___1" then
                        posX = 405
                    end
                    for j, facePath in pairs(targetFaceFile) do
                        copyImage(0, imageFileNum)
                        local blendImageNum = imageFileList[facePath]
                        blendImage(0, blendImageNum, 1, posX, posY)
                        if isTrim == "1" then
                            trimmingImage(0, "UDLR")
                        end
                        local faceNum = string.match(getBaseName(facePath), "[0-9][0-9][0-9][0-9]$") or
                                        getBaseName(facePath)
                        local outputFileName = outputDir .. subDir .. headName .. "_" .. faceNum .. ".png"
                        saveImage(0, outputFileName, 1, 0, tonumber(compressLevel), 0)
                        print("output: " .. outputFileName .. "\n")
                    end
                -- sv̉摜
                elseif targetFaceFile == nil or notTarget ~= nil then
                    loadImage(0, path)
                    if isTrim == "1" then
                        trimmingImage(0, "UDLR")
                    end
                    local outputFileName = outputDir .. subDir .. getBaseName(path) .. ".png"
                    saveImage(0, outputFileName, 1, 0, tonumber(compressLevel), 0)
                    print("output: " .. outputFileName .. "\n")
                end
            -- face
            elseif partType == "_" then
                -- \̓Ǎ
                local nilFile = string.match(getBaseName(path), "0000$")
                if not nilFile then
                    loadImage(imageFileNum, path)
                    -- ǂݍ񂾉摜ƓǍԍ̕Rt
                    imageFileList[path] = imageFileNum
                    imageFileNum = imageFileNum + 1
                    -- \̎ޕ
                    if not faceFile[fileType] then
                        faceFile[fileType] = {}
                    end
                    table.insert(faceFile[fileType], path)
                end
            end

        end
        -- if "*.bmp or *.png" end
    end
    -- loop "file path" end
end
